<template>
  <div class="student-data">

    <b-field label="CPF" message="CPF sem pontos ou traços" class="has-text-weight-bold">
      <b-input
        id="studentCPF"
        name="studentCPF"
        v-model="studentCPF"
        maxlength="11"
        expanded
        pattern="^(\d{11})$"
        validation-message="Apenas sequência numérica de 12 dígitos"
        required
        value="">
      </b-input>
    </b-field>

    <b-field label="Matrícula">
      <b-input
        id="studentRegistration"
        name="studentRegistration"
        v-model="studentRegistration"
        maxlength="14"
        expanded
        pattern="^(\d{14}|\d{13})$"
        validation-message="Apenas sequência numérica de 14 dígitos"
        required
        value="">
      </b-input>
    </b-field>

    <b-notification
      v-if="error"
      class="miss-student-notification"
      type="is-danger"
      has-icon
      aria-close-label="Fechar notificação"
      role="alert">
      A matrícula e/ou o CPF informados não estão em nosso banco de dados. Isso pode acontecer por vários motivos. Os
      principais são:
      <ul>
        <li><b-icon size="is-small" icon="check"></b-icon> A matrícula não corresponde ao CPF informado, ou vice-versa;</li>
        <li><b-icon size="is-small" icon="check"></b-icon> Sua matrícula ainda não está em nossa base de dados, pode acontecer caso você seja aluno novo;
        Nesse caso, entre em contato com a área de T.I do campus.</li>
      </ul>
    </b-notification>

    <b-notification
      v-if="dataError"
      class="miss-student-notification"
      type="is-warning"
      has-icon
      aria-close-label="Fechar notificação"
      role="alert">
      A matrícula e/ou o CPF informados não correspondem a um mesmo cadastro em nosso banco de dados. Isso pode acontecer pelos seguintes motivos:
      <ul>
        <li><b-icon size="is-small" icon="check"></b-icon> A matrícula existe no banco de dados, mas o CPF não;</li>
        <li><b-icon size="is-small" icon="check"></b-icon> A matrícula existe no banco de dados, mas não está vinculada ao CPF informado;</li>
        <li><b-icon size="is-small" icon="check"></b-icon> A matrícula <strong>não</strong> existe no banco de dados. Entre em contato com a área de T.I do campus.</li>
      </ul>
    </b-notification>

    <div class="buttons">
      <b-button
        @click="onChange($event)"
        :disabled="isDisabled"
        class="button is-primary">Procurar dados</b-button>
      <b-button
        type="is-warning"
        @click="cancel">
        Cancelar
      </b-button>
    </div>

    <b-loading :is-full-page="true" :active.sync="isLoading" :can-cancel="false"></b-loading>
  </div>
</template>

<script>
import Vue from 'vue'
import axios from 'axios'
import messages from '@/utils/messages'
// import ifcaptcha from '@/utils/ifcaptcha'

export default {
  name: 'StudentData',
  props: {},
  data: function ()  {
    return {
      studentRegistration: '',
      studentCPF: '',
      isLoading: false,
      error: false,
      dataError: false
    }
  },
  created () {
		// ifcaptcha.showCaptcha()
	},
  components: {},
  methods: {
    save () {},
    cancel () {
      this.$router.go(-1)
    },
    onChange () {
      this.isLoading = true
      var message = ''
      var url = Vue.config.urlBase + '/api/estudantes/' + this.studentRegistration
      var options = {
        headers: {
          Accept: 'application/json',
        }
      }
      axios.get(url, options)
        .then(response => {
          var student = response.data
          // student['studentRegistration'] = this.studentRegistration
          if (student.cpf == this.studentCPF) {
            this.$emit('userChanged', student)
          } else {
            this.dataError = true
          }
          return response
        })
        .catch(error => {
          if (error.response.status == 500) {
            message = 'Requisição falhou: erro interno do servidor (500).'
            messages.showSnackbar(message, 'is-danger')
          } else if (error.response.status === 401) {
            message = 'Requisição falhou: não autorizado (401).'
            messages.showSnackbar(message, 'is-danger')
          } else if (error.response.status === 404) {
            this.error = true
            this.dataError = false
            // message = 'Requisição falhou: recurso não encontrado (404).'
            // messages.showSnackbar(message, 'is-danger')
          } else {
            message = 'Requisição falhou: ' + error.toString().split(':')[1] + '.'
            messages.showSnackbar(message, 'is-danger')
          }
          return error
        })
        .finally(() => {
          this.isLoading = false
      })
    },

  },
  computed: {
    campus () {
      return process.env.VUE_APP_IF_CAMPUS
    },
    isDisabled () {
      let sr = this.studentRegistration.length
      let sc = this.studentCPF.length
      return (sr == 14 && sc == 11 ? false : true)
    }
  }
}
</script>
<!-- Add "scoped" attribute to limit CSS to this component only -->
<style scoped lang="css">
</style>
